#ifndef __CS_HUB_ANDROID_H__
#define __CS_HUB_ANDROID_H__

#include <stdbool.h>
#include "C2SHub2.h"

#ifdef __cplusplus
extern "C" {
#endif

int initializeEx(const char *appId, HiveSocialServerState serverType);

//// login
int auth(HubCallbackWithJSON closeCallback, void *callbackParam);
int authWithParam(const char *param, HubCallbackWithJSON closeCallback, void *callbackParam);

//// logout
int logout(HubCallbackWithJSON closeCallback, void *callbackParam);
//// userDelete
int userDelete(HubCallbackWithJSON closeCallback, void *callbackParam);

//// Web Dialog
int showDialog(const char *relativePath, HubCallbackWithJSON closeCallback, void *callbackParam);
int showDialogForChatbot(const char *param, HubCallbackWithJSON closeCallback, void *callbackParam);    // addee v2.8.1

//// Hive API Request
int asyncRequest(const char *requestName, const char *params, HubCallbackWithJSON closeCallback, void *callbackParam);

//// Social API Request
int socialRequestWithService(const char *socialService, const char *actionName, const char *params, HubCallbackWithJSON responseCallback, void *callbackParam);

//// Guest
int guestAcquireUid(HubCallbackWithJSON closeCallback,void *callbackParam);
int guestBind(const char *guestUid, const char *candidateUid, HubCallbackWithJSON closeCallback,void *callbackParam);


int setPGSAutoLogin();
int setPGSAutoLoginWithCB(HubCallbackWithJSON closeCallback, void *callbackParam);
//// auth by PGS
int authByPGS(HubCallbackWithJSON closeCallback, void *callbackParam);
int isPGSAvailable();

int setAuthDialogClear();

#if __ANDORID__
JNIEXPORT void JNICALL Java_com_com2us_peppermint_HubBridge_callCSHubInitialize(JNIEnv *env, jclass cls);

JNIEXPORT void JNICALL Java_com_com2us_peppermint_HubBridge_callTempJSONResponse(JNIEnv *env, jclass cls, jstring jResponseJSONString);
#endif


#ifdef __cplusplus
}
#endif

#endif

