#ifdef __ANDROID__
#include <jni.h>
#include <android/log.h>
#include "C2SActiveUser.h"

#include "CMErrors.h"
#include <string.h>


static JavaVM* g_vm;
static jobject g_obj = NULL;
static jclass  g_cls = NULL;

static jobject g_obj_useragree = NULL;
static jclass g_cls_useragree = NULL;

//static jobject g_obj_version = NULL;
//static jclass  g_cls_version = NULL;
#define TAG "ActiveUser"

//void
//logD(
//	char* format,
//	...
//	)
//{
//	va_list	ap;
//#if defined(TAG)
//	char	buffer[1024];
//#endif
//
//	va_start(ap, format);
//#if !defined(TAG)
//	vprintf((const char*) format, ap);
//#else
//	 (int) vsnprintf(buffer, sizeof(buffer) / sizeof(buffer[0]), (const char*) format, ap);
//#endif
//	va_end(ap);
//
//#if defined(TAG)
//	__android_log_print(ANDROID_LOG_DEBUG, TAG, buffer);
//#endif
//
//}

//#ifdef USER_AGREE_DEBUG
//	#include <android/log.h>
//
//	#define LOGV(...) __android_log_print(ANDROID_LOG_VERBOSE, "libnav", __VA_ARGS__)
//	#define LOGD(...) __android_log_print(ANDROID_LOG_DEBUG  , "libnav", __VA_ARGS__)
//	#define LOGI(...) __android_log_print(ANDROID_LOG_INFO   , "libnav", __VA_ARGS__)
//	#define LOGW(...) __android_log_print(ANDROID_LOG_WARN   , "libnav", __VA_ARGS__)
//	#define LOGE(...) __android_log_print(ANDROID_LOG_ERROR  , "libnav", __VA_ARGS__)
//#endif

//void Java_com_com2us_module_activeuser_ActiveUser_jniInitialize(JNIEnv* env, jobject obj,jobject obj_useragree,jobject obj_vesrion)
JNIEXPORT void JNICALL
Java_com_com2us_module_activeuser_ActiveUser_jniInitialize(JNIEnv* env, jobject obj, jobject obj_useragree)
{
//   logD("(jniInitialize)");
   (*env)->GetJavaVM(env, &g_vm);
    g_obj = (*env)->NewGlobalRef(env, obj);
    g_cls = (*env)->NewGlobalRef(env, (*env)->GetObjectClass(env,g_obj));

    g_obj_useragree = (*env)->NewGlobalRef(env, obj_useragree);
    g_cls_useragree = (*env)->NewGlobalRef(env, (*env)->GetObjectClass(env, g_obj_useragree));


//    g_obj_version = (*env)->NewGlobalRef(env, obj_vesrion);
//    g_cls_version = (*env)->NewGlobalRef(env, (*env)->GetObjectClass(env, g_obj_version));

}

//void Java_com_com2us_module_activeuser_ActiveUser_jniUninitialize(JNIEnv* env, jobject obj)
JNIEXPORT void JNICALL
Java_com_com2us_module_activeuser_ActiveUser_jniUninitialize(JNIEnv* env, jobject obj)
{
//	 logD("(jniUninitialize)");

	(*env)->DeleteGlobalRef(env,g_obj);
	(*env)->DeleteGlobalRef(env,g_cls);
	(*env)->DeleteGlobalRef(env,g_obj_useragree);
	(*env)->DeleteGlobalRef(env,g_cls_useragree);
//	(*env)->DeleteGlobalRef(env,g_obj_version);
//	(*env)->DeleteGlobalRef(env,g_cls_version);

}

void CS_ActiveUserSetLogged(int isLogged){

	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID	methodID
		= (*env)->GetMethodID(env,g_cls, "setLogged" , "(Z)V");

		if(methodID !=0){
			(*env)->CallVoidMethod(env, g_obj,methodID, (jboolean)isLogged);
		}
	}
}

void CS_ActiveUserSetEnableRequestStoragePermission() {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "setEnableRequestStoragePermission", "()V");

		if(g_cls != 0 && method != 0 )
		{
			(*env)->CallVoidMethod(env, g_obj, method);
		}
	}
}


int CS_ActiveUserGetVersion(char* buf, int bufSize){

	JNIEnv*	env;
	char * versionChar;
	jstring version;
	jboolean isCopyVersion;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID	methodID
		= (*env)->GetMethodID(env,g_cls, "getVersion" , "()Ljava/lang/String;");

		if(methodID !=0){
			version = (jstring)(*env)->CallObjectMethod(env, g_obj, methodID);

			versionChar = (*env)->GetStringUTFChars(env, version, &isCopyVersion);
			int len = strlen(versionChar);

			if( (len +1) > bufSize ){

				return CM_E_SHORTBUF;
			}

			strcpy(buf, versionChar);
//			buf[len] ='\0';
			if(isCopyVersion == JNI_TRUE)
				(*env)->ReleaseStringUTFChars(env, version, versionChar);
			return CM_E_SUCCESS;
		}
	}
	return CM_E_ERROR;

}


void CS_ActiveUserStart(){
	int ret = 0;
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID	methodID
		= (*env)->GetMethodID(env,g_cls, "start" , "()V");

		if(methodID !=0){
			(*env)->CallVoidMethod(env, g_obj,methodID);
		}
	}
}


void CS_ActiveUserStartEx(SERVER_STATE serverState){
	int ret = 0;
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID	methodID
		= (*env)->GetMethodID(env,g_cls, "start" , "(Lcom/com2us/module/manager/ModuleManager$SERVER_STATE;)V");

		if(methodID !=0){

			const char* stateOne;
			switch(serverState) {
			case STAGING_SERVER:
				stateOne = "STAGING_SERVER";
				break;
			case SANDBOX_SERVER:
				stateOne = "SANDBOX_SERVER";
				break;
			case LIVE_SERVER:
			default:
				stateOne = "LIVE_SERVER";
				break;
			}

			jclass theSERVER_STATEClass = (*env)->FindClass(env, "com/com2us/module/manager/ModuleManager$SERVER_STATE");
			jfieldID stateOneField = (*env)->GetStaticFieldID(env, theSERVER_STATEClass , stateOne, "Lcom/com2us/module/manager/ModuleManager$SERVER_STATE;");
			jobject STATE_ONE = (*env)->GetStaticObjectField(env, theSERVER_STATEClass, stateOneField);

			(*env)->CallVoidMethod(env, g_obj,methodID, STATE_ONE);
		}
	}
}


void CS_ActiveUserStartWithoutNotice(SERVER_STATE serverState, int showNoticePopup){
	int ret = 0;
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID	methodID
		= (*env)->GetMethodID(env,g_cls, "start" , "(Lcom/com2us/module/manager/ModuleManager$SERVER_STATE;Z)V");

		if(methodID !=0){

			const char* stateOne;
			switch(serverState) {
			case STAGING_SERVER:
				stateOne = "STAGING_SERVER";
				break;
			case SANDBOX_SERVER:
				stateOne = "SANDBOX_SERVER";
				break;
			case LIVE_SERVER:
			default:
				stateOne = "LIVE_SERVER";
				break;
			}

			jclass theSERVER_STATEClass = (*env)->FindClass(env, "com/com2us/module/manager/ModuleManager$SERVER_STATE");
			jfieldID stateOneField = (*env)->GetStaticFieldID(env, theSERVER_STATEClass , stateOne, "Lcom/com2us/module/manager/ModuleManager$SERVER_STATE;");
			jobject STATE_ONE = (*env)->GetStaticObjectField(env, theSERVER_STATEClass, stateOneField);

			(*env)->CallVoidMethod(env, g_obj,methodID, STATE_ONE, (jboolean)showNoticePopup);
		}
	}
}


/* C 문자열로부터 자바 바이트 배열을 생성하여 반환 */
jbyteArray cstrTojbyteArray( JNIEnv *env, const char *nativeStr)
{
    jbyteArray javaBytes;

    int len = strlen( nativeStr );
    javaBytes = (*env)->NewByteArray(env, len);

    (*env)->SetByteArrayRegion( env, javaBytes, 0, len, (jbyte*)nativeStr );
    return javaBytes;
}

// prefix UserAgree_(avoid crash with other module)
char* jbyteArrayTocstr( JNIEnv* env, jbyteArray javaBytes, int* new_len )
{
	char *nativeStr;

	size_t len = (*env)->GetArrayLength(env, javaBytes);

	jbyte *nativeBytes = (*env)->GetByteArrayElements(env, javaBytes, 0);

	nativeStr = (char *)malloc(len+1);

	strncpy( nativeStr, nativeBytes, len );
	nativeStr[len] = '\0';

	*new_len = (int) len;
	(*env)->ReleaseByteArrayElements(env, javaBytes, nativeBytes, JNI_ABORT);

	return nativeStr;
}



// apply to 64bit system
JNIEXPORT void JNICALL
Java_com_com2us_module_activeuser_ActiveUser_jniUserAgreeNotifier(JNIEnv* env, jobject obj , jlong callbackPointer, jint state){

//	logD("(nativeReceivedResponse) message : %s period : %d url : %s",(char*)message,(char*)url);

	UserAgreeCB cb = (UserAgreeCB)callbackPointer;
	cb((int)state);
}

// apply to 64bit system
void CS_UserAgreeSetCallback(UserAgreeCB cb) {

	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID	methodID
		= (*env)->GetMethodID(env, g_cls,  "setJNIUserAgreeNotifier" , "(J)V");

		if(methodID !=0){
			(*env)->CallVoidMethod(env, g_obj, methodID, (jlong)cb);
		}
	}
}

// apply to 64bit system
JNIEXPORT void JNICALL
Java_com_com2us_module_activeuser_ActiveUser_jniActiveUserNotifier(JNIEnv* env, jobject obj ,jlong callbackPointer, jint state){

//	logD("(nativeReceivedResponse) message : %s period : %d url : %s",(char*)message,(char*)url);

	ActiveUserCB cb = (ActiveUserCB)callbackPointer;
	cb((int)state);
}

// apply to 64bit system
void CS_ActiveUserSetCallback(ActiveUserCB cb) {

	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID	methodID
		= (*env)->GetMethodID(env, g_cls,  "setJNIActiveUserNotifier" , "(J)V");

		if(methodID !=0){
			(*env)->CallVoidMethod(env, g_obj, methodID, (jlong)cb);
		}
	}
}

const char* CS_ActiveUserGetDID() {

	JNIEnv* env = 0;
	jmethodID method;

	jstring jdid = 0;
	char* ret = "0";

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetStaticMethodID(env, g_cls, "getDID", "()Ljava/lang/String;");

		if(g_cls != 0 && method != 0 )
		{
			jdid = (jstring)(*env)->CallStaticObjectMethod(env, g_cls, method);
		}
	}

	if(jdid != 0) {
		ret = strdup( (*env)->GetStringUTFChars(env, jdid, 0) );
		(*env)->DeleteLocalRef(env, jdid);
		/* (ret == '\0') == (ret == NULL) == (ret == 0) */
		if (ret != NULL)
		{
			if (ret[0] == '\0')
			{
				free(ret);
				ret = 0;    /* or ret = NULL; */
			}
		}
	}
	return ret;
}

void CS_ActiveUserSetServerId(const char* server_id) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "setServerId", "(Ljava/lang/String;)V");

		if(g_cls != 0 && method != 0 )
		{
			jstring jserver_id = (*env)->NewStringUTF(env, server_id);
			(*env)->CallVoidMethod(env, g_obj, method, jserver_id);
		}
	}
}

// apply to 64bit system
void CS_UpdateNoticeShowPopup(UpdateNoticePopupCB cb) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "jniShowNoticePopup", "(J)V");

		if(g_cls != 0 && method != 0 )
		{
			(*env)->CallVoidMethod(env, g_obj, method, (jlong)cb);
		}
	}
}

// apply to 64bit system
void CS_UpdateNoticeGetPopupInfo(UpdateNoticeInfoCB cb) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "jniGetNoticePopupInfo", "(J)V");		// get method Id

		if(g_cls != 0 && method != 0 )		// class info(g_cls) check, method ID(jmethodID method) check
		{
			(*env)->CallVoidMethod(env, g_obj, method, (jlong)cb);		// call method(type=void) --> jniGetNoticePopupInfo
		}
	}
}

// apply to 64bit system
void CS_ActiveUserGetPermissionViewData(PermissionViewDataCB cb) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "jniRequestPermissionViewData", "(J)V");		// get method Id

		if(g_cls != 0 && method != 0 )		// class info(g_cls) check, method ID(jmethodID method) check
		{
			(*env)->CallVoidMethod(env, g_obj, method, (jlong)cb);		// call method(type=void) --> jniRequestPermissionViewData
		}
	}
}

char*
ActiveUser_jstringToChar(JNIEnv* env, jstring str)
{
	char* cDesc = strdup( (*env)->GetStringUTFChars(env, str, 0) );
//	(*env)->ReleaseStringUTFChars(env, str, cDesc);
	return cDesc;
}

// apply to 64bit system
JNIEXPORT void JNICALL
Java_com_com2us_module_activeuser_ActiveUser_jniNoticeShowPopupNotifier(JNIEnv* env, jobject obj , jlong callbackPointer, jint popupState) {

	UpdateNoticePopupCB cb = (UpdateNoticePopupCB)callbackPointer;

	switch(popupState) {
	case CLOSE:
		cb(CLOSE);
		break;
	case UNSHOWN:				// added 2.6.8
		cb(UNSHOWN);
		break;
	case POPUP_STATE_ERROR:		// added 2.6.10
		cb(POPUP_STATE_ERROR);
		break;
	default:
		break;
	}
}

// apply to 64bit system
JNIEXPORT void JNICALL
Java_com_com2us_module_activeuser_ActiveUser_jniNoticePopupNotifier(JNIEnv* env, jobject obj , jlong callbackPointer, jint popupType, jstring jsonData) {

	UpdateNoticeInfoCB cb = (UpdateNoticeInfoCB)callbackPointer;

	char* data = (jsonData == NULL) ? NULL : ActiveUser_jstringToChar(env, jsonData);		// modified 2.8.4

	switch(popupType) {
	case SHOW:
		cb(SHOW, data);
		break;
	case NOTSHOW:
		cb(NOTSHOW, data);
		break;
	case SHOW_POPUP_ERROR:		// added 2.6.10
		cb(SHOW_POPUP_ERROR, data);
		break;
	default:
		break;
	}

	if(data != NULL)
		(*env)->ReleaseStringUTFChars(env, jsonData, data);		// for memory release, modified 2.8.4
}

// apply to 64bit system
JNIEXPORT void JNICALL
Java_com_com2us_module_activeuser_ActiveUser_jniPermissionViewDataNotifier(JNIEnv* env, jobject obj , jlong callbackPointer, jstring jsonData) {

	PermissionViewDataCB cb = (PermissionViewDataCB)callbackPointer;

	char* data = (jsonData == NULL) ? NULL : ActiveUser_jstringToChar(env, jsonData);

	cb(data);

	if(data != NULL)
		(*env)->ReleaseStringUTFChars(env, jsonData, data);
}

void CS_ActiveUserSetGameLanguage(const char* game_language) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "setGameLanguage", "(Ljava/lang/String;)V");

		if(g_cls != 0 && method != 0 )
		{
			jstring jgame_language = (*env)->NewStringUTF(env, game_language);
			(*env)->CallVoidMethod(env, g_obj, method, jgame_language);
		}
	}
}

void CS_SetMinTimeoutSeconds(int seconds) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "setNetworkTimeoutSeconds", "(I)V");

		if(g_cls != 0 && method != 0 )
		{
			jint jseconds = (jint)seconds;
			(*env)->CallVoidMethod(env, g_obj, method, jseconds);
		}
	}
}

void CS_ActiveUserSetPermissionViewState(int isOn){

	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID	methodID
				= (*env)->GetMethodID(env,g_cls, "setIsShowPermissionView" , "(Z)V");

		if(methodID !=0){
			(*env)->CallVoidMethod(env, g_obj,methodID, (jboolean)isOn);
		}
	}
}

void CS_ActiveUserSendFunnelsLogs(const char* funnelsTrack, const char* optionTag) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "sendFunnelsLogs", "(Ljava/lang/String;Ljava/lang/String;)V");

		if(g_cls != 0 && method != 0 )
		{
			jstring jfunnelsTrack = (*env)->NewStringUTF(env, funnelsTrack);
			jstring joptionTag = (*env)->NewStringUTF(env, optionTag);
			(*env)->CallVoidMethod(env, g_obj, method, jfunnelsTrack, joptionTag);
		}
	}
}

int CS_SetEmergencyModeWithUid(const char* uid) {

    JNIEnv* env = 0;
    jmethodID method;

    if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
    {
        method = (*env)->GetMethodID(env, g_cls, "setEmergencyModeWithUid", "(Ljava/lang/String;)I");

        if(g_cls != 0 && method != 0 )
        {
            jstring jUid = (*env)->NewStringUTF(env, uid);
            return (*env)->CallIntMethod(env, g_obj, method, jUid);
        }
    }
}

// apply to 64bit system
void CS_ActiveUserRequestUserPermissions(const char* requests, RequestUserPermissionsCB cb) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "jniRequestUserPermissions", "(Ljava/lang/String;J)V");		// get method Id

		if(g_cls != 0 && method != 0 )		// class info(g_cls) check, method ID(jmethodID method) check
		{
			jstring jrequests = (*env)->NewStringUTF(env, requests);
			(*env)->CallVoidMethod(env, g_obj, method, jrequests, (jlong)cb);
		}
	}
}

void CS_ActiveUserUpdateServerId(const char* server_id) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "updateServerId", "(Ljava/lang/String;)V");

		if(g_cls != 0 && method != 0 )
		{
			jstring jserver_id = (*env)->NewStringUTF(env, server_id);
			(*env)->CallVoidMethod(env, g_obj, method, jserver_id);
		}
	}
}

void CS_ActiveUserUpdateGameLanguage(const char* game_language) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "updateGameLanguage", "(Ljava/lang/String;)V");

		if(g_cls != 0 && method != 0 )
		{
			jstring jgame_language = (*env)->NewStringUTF(env, game_language);
			(*env)->CallVoidMethod(env, g_obj, method, jgame_language);
		}
	}
}

void CS_SetAnalyticsLogSettings(int sendLimit, int queueLimit, int sendCycleSecond) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "setAnalyticsLogSettings", "(III)V");

		if(g_cls != 0 && method != 0 )
		{
			jint jsendLimit = (jint)sendLimit;
			jint jqueueLimit = (jint)queueLimit;
			jint jsendCycleSecond = (jint)sendCycleSecond;
			(*env)->CallVoidMethod(env, g_obj, method, jsendLimit, jqueueLimit, jsendCycleSecond);
		}
	}
}

void CS_UserAgreeShowTermsUI(void* parentView) {
	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "showUserAgreeTerms", "()V");

		if(g_cls != 0 && method != 0 )
		{
			(*env)->CallVoidMethod(env, g_obj, method);
		}
	}
}

void CS_UserAgreeShowTermsUIEx(void* parentView, const char* url) {

	JNIEnv* env = 0;
	jmethodID method;

	if( (*g_vm)->GetEnv( g_vm, (void **)&env, JNI_VERSION_1_6 ) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "showUserAgreeTerms", "(Ljava/lang/String;)V");

		if(g_cls != 0 && method != 0 )
		{
			jstring jurl = (*env)->NewStringUTF(env, url);
			(*env)->CallVoidMethod(env, g_obj, method, jurl);
		}
	}
}


int CS_SendAnalyticsLog(const char* logData) {

	JNIEnv*	env = 0;
	jmethodID method;
	jint result;

	if( (*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK )
	{
		method = (*env)->GetMethodID(env, g_cls, "sendAnalyticsLog" , "(Ljava/lang/String;)I");

		if(g_cls != 0 && method != 0)
		{
			jstring jlogData = (*env)->NewStringUTF(env, logData);
			return (*env)->CallIntMethod(env, g_obj, method, jlogData);
		}
	}
	return 0;	// fail
}

void CS_SetModuleOrientation(MODULE_ORIENTATION orientation) {

	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID methodID = (*env)->GetMethodID(env, g_cls, "setModuleOrientation" , "(I)V");

		if(methodID !=0){
			(*env)->CallVoidMethod(env, g_obj, methodID, (jint)orientation);
		}
	}
}

void CS_SetUseHercules(int enable) {

	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID	methodID
				= (*env)->GetMethodID(env,g_cls, "setUseHercules" , "(Z)V");

		if(methodID !=0){
			(*env)->CallVoidMethod(env, g_obj,methodID, (jboolean)enable);
		}
	}
}

// apply to 64bit system
JNIEXPORT void JNICALL
Java_com_com2us_module_activeuser_ActiveUser_jniRequestUserPermissionsNotifier(JNIEnv* env, jobject obj, jlong callbackPointer, jint state, jstring grantedPermissions, jstring deniedPermissions) {

	RequestUserPermissionsCB cb = (RequestUserPermissionsCB)callbackPointer;

	char* grantedData = (grantedPermissions == NULL) ? NULL : ActiveUser_jstringToChar(env, grantedPermissions);
	char* deniedData = (deniedPermissions == NULL) ? NULL : ActiveUser_jstringToChar(env, deniedPermissions);

	switch(state) {
		case SUCCESS:
			cb(SUCCESS, grantedData, deniedData);
			break;
		case ERROR:
			cb(ERROR, grantedData, deniedData);
			break;
		case NOT_SUPPORT_OS_VERSION:
			cb(NOT_SUPPORT_OS_VERSION, grantedData, deniedData);
			break;
		case WRONG_TYPE_DATA:
			cb(WRONG_TYPE_DATA, grantedData, deniedData);
			break;
		default:
			break;
	}

	if(grantedData != NULL)
		(*env)->ReleaseStringUTFChars(env, grantedPermissions, grantedData);
	if(deniedData != NULL)
		(*env)->ReleaseStringUTFChars(env, deniedPermissions, deniedData);
}
#endif
