#ifdef __ANDROID__
#include <stdlib.h>
#include <stdio.h>
#include "C2SHub2.h"
#include "C2SHub2Android.h"

#ifdef __cplusplus
extern "C" {
#endif


#pragma mark - Module State
int CS_hubInitializeEx(const char *appId, HiveSocialServerState serverType)
{
	return initializeEx(appId, serverType);
}

#pragma mark - Authentication
int CS_hubAuth(HubCallbackWithJSON closeCallback, void *callbackParam)
{
	return auth(closeCallback, callbackParam);
}

int CS_hubAuthWithParam(const char *param, HubCallbackWithJSON closeCallback, void *callbackParam)
{
	return authWithParam(param, closeCallback, callbackParam);
}

int CS_hubLogout(HubCallbackWithJSON closeCallback, void *callbackParam)
{
	return logout(closeCallback, callbackParam);
}

int CS_hubUserDelete(HubCallbackWithJSON closeCallback, void *callbackParam)
{
	return userDelete(closeCallback, callbackParam);
}

#pragma mark - Guest
int CS_hubGuestAcquireUid(HubCallbackWithJSON	closeCallback, void *callbackParam)
{
	return guestAcquireUid(closeCallback,callbackParam);
}

int CS_hubGuestBind(const char *guestUid, const char *candidateUid, HubCallbackWithJSON	closeCallback, void *callbackParam)
{
	return guestBind(guestUid, candidateUid, closeCallback,callbackParam);
}

#pragma mark - UI
int CS_hubShowDialog(const char *relativePath, HubCallbackWithJSON closeCallback, void *callbackParam)
{
	return showDialog(relativePath, closeCallback, callbackParam);
}

int CS_hubShowDialogForChatbot(const char *param, HubCallbackWithJSON closeCallback, void *callbackParam)
{
	return showDialogForChatbot(param, closeCallback, callbackParam);
}

#pragma mark - General Request
int CS_hubAsyncRequest(const char *requestName,	const char *params,	HubCallbackWithJSON responseCallback, void *callbackParam)
{
	return asyncRequest(requestName, params, responseCallback,callbackParam);
}

int CS_hubSocialRequest(const char *socialService, const char *requestName, const char *params, HubCallbackWithJSON responseCallback, void *callbackParam)
{
	return socialRequestWithService(socialService, requestName, params, responseCallback, callbackParam);
}

// 2.9.14 - pgs auto login enable
int CS_hubSetPGSAutoLogin()
{
	return setPGSAutoLogin();
}

int CS_hubSetPGSAutoLoginWithCB(HubCallbackWithJSON closeCallback, void *callbackParam)
{
	return setPGSAutoLoginWithCB(closeCallback, callbackParam);
}

// auth by PGS
int CS_hubAuthByPGS(HubCallbackWithJSON closeCallback, void *callbackParam)
{
	return authByPGS(closeCallback, callbackParam);
}

int CS_hubIsPGSAvailable()
{
	return isPGSAvailable();
}

int CS_hubSetAuthDialogClear()
{
	return setAuthDialogClear();
}

#ifdef __cplusplus
}
#endif

#endif
