#ifdef __ANDROID__
#include <jni.h>
#include <string.h>
#include <stdbool.h>		// boolean function type
#include "C2SPush.h"

#include <malloc.h>

static JavaVM* g_vm;
static jobject g_obj = 0;
static jclass  g_cls = 0;

JNIEXPORT void JNICALL
Java_com_com2us_module_push_Push_jniPushInitialize(JNIEnv* env, jobject thiz, jobject obj)
{
	(*env)->GetJavaVM(env, &g_vm);
	g_obj = (*env)->NewGlobalRef(env, obj);
	g_cls = (*env)->NewGlobalRef(env, (*env)->GetObjectClass(env, obj));
}

JNIEXPORT void JNICALL
Java_com_com2us_module_push_Push_jniPushUninitialize(JNIEnv* env, jobject thiz)
{
	(*env)->DeleteGlobalRef(env, g_obj);
	(*env)->DeleteGlobalRef(env, g_cls);
}

void CS_pushSetPush(Push_BoolType isPush) {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "setPush", "(I)V");
		if (method != 0) {
			(*env)->CallVoidMethod(env, g_obj, method, isPush);
		}
	}
}

void CS_pushSetAgree(Push_BoolType isNotice, Push_BoolType isNight) {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "setAgree", "(II)V");
		if (method != 0) {
			(*env)->CallVoidMethod(env, g_obj, method, isNotice, isNight);
		}
	}
}

Push_BoolType CS_pushGetPush() {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "getPush", "()I");
		if (method != 0) {
			return (*env)->CallIntMethod(env, g_obj, method);
		}
	}

	return DEFAULT_TRUE;
}

Push_BoolType CS_pushGetAgreeNotice() {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "getAgreeNotice", "()I");
		if (method != 0) {
			return (*env)->CallIntMethod(env, g_obj, method);
		}
	}

	return Push_TRUE;
}

Push_BoolType CS_pushGetAgreeNight() {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "getAgreeNight", "()I");
		if (method != 0) {
			return (*env)->CallIntMethod(env, g_obj, method);
		}
	}

	return Push_FALSE;
}

const char* CS_PushGetVersion() {
	JNIEnv *env = 0;
	jmethodID method;

	jstring jversion = 0;
	char *ret = "0";

	if (JNI_OK == (*g_vm)->GetEnv(g_vm, (void **) &env, JNI_VERSION_1_6)) {
		method = (*env)->GetMethodID(env, g_cls, "getVersion", "()Ljava/lang/String;");
		if (0 != method) {
			jversion = (jstring) (*env)->CallObjectMethod(env, g_obj, method);
		}
	}

	if (jversion != 0) {
		ret = strdup((*env)->GetStringUTFChars(env, jversion, 0));
		(*env)->DeleteLocalRef(env, jversion);
		/* (ret == '\0') == (ret == NULL) == (ret == 0) */
		if (ret != NULL) {
			if (ret[0] == '\0') {
				free(ret);
				ret = 0;    /* or ret = NULL; */
			}
		}
	}

	return ret;
}

void CS_pushRegisterLocalpush(int pushID, char* title, char* msg, char* ticker, char* type, char* icon, char* sound, char* active, long after) {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "registerLocalpush", "(ILjava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;J)V");
		if (method != 0) {
			jstring jtitle = (*env)->NewStringUTF(env, title);
			jstring jmsg = (*env)->NewStringUTF(env, msg);
			jstring jticker = (*env)->NewStringUTF(env, ticker);
			jstring jtype = (*env)->NewStringUTF(env, type);
			jstring jicon = (*env)->NewStringUTF(env, icon);
			jstring jsound = (*env)->NewStringUTF(env, sound);
			jstring jactive = (*env)->NewStringUTF(env, active);

			(*env)->CallVoidMethod(env, g_obj, method, pushID, jtitle, jmsg, jticker, jtype, jicon, jsound, jactive, (jlong)after);

			if (jtitle != 0) (*env)->DeleteLocalRef(env, jtitle);
			if (jmsg != 0) (*env)->DeleteLocalRef(env, jmsg);
			if (jticker != 0) (*env)->DeleteLocalRef(env, jticker);
			if (jtype != 0) (*env)->DeleteLocalRef(env, jtype);
			if (jicon != 0) (*env)->DeleteLocalRef(env, jicon);
			if (jsound != 0) (*env)->DeleteLocalRef(env, jsound);
			if (jactive != 0) (*env)->DeleteLocalRef(env, jactive);
		}
	}
}

void CS_pushRegisterLocalpushEx(int pushID, char* title, char* msg, char* ticker, char* type, char* icon, char* sound, char* active, long after, char* broadcastAction) {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "registerLocalpush", "(ILjava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;JLjava/lang/String;)V");
		if (method != 0) {
			jstring jtitle = (*env)->NewStringUTF(env, title);
			jstring jmsg = (*env)->NewStringUTF(env, msg);
			jstring jticker = (*env)->NewStringUTF(env, ticker);
			jstring jtype = (*env)->NewStringUTF(env, type);
			jstring jicon = (*env)->NewStringUTF(env, icon);
			jstring jsound = (*env)->NewStringUTF(env, sound);
			jstring jactive = (*env)->NewStringUTF(env, active);
			jstring jbroadcastAction = (*env)->NewStringUTF(env, broadcastAction);

			(*env)->CallVoidMethod(env, g_obj, method, pushID, jtitle, jmsg, jticker, jtype, jicon, jsound, jactive, (jlong)after, jbroadcastAction);

			if (jtitle != 0) (*env)->DeleteLocalRef(env, jtitle);
			if (jmsg != 0) (*env)->DeleteLocalRef(env, jmsg);
			if (jticker != 0) (*env)->DeleteLocalRef(env, jticker);
			if (jtype != 0) (*env)->DeleteLocalRef(env, jtype);
			if (jicon != 0) (*env)->DeleteLocalRef(env, jicon);
			if (jsound != 0) (*env)->DeleteLocalRef(env, jsound);
			if (jactive != 0) (*env)->DeleteLocalRef(env, jactive);
			if (jbroadcastAction != 0) (*env)->DeleteLocalRef(env, jbroadcastAction);
		}
	}
}

void CS_pushRegisterLocalpushBig(int pushID, char* title, char* msg, char* bigmsg, char* ticker, char* type, char* icon, char* sound, char* active, long after, char* broadcastAction) {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "registerLocalpush", "(ILjava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;JLjava/lang/String;)V");
		if (method != 0) {
			jstring jtitle = (*env)->NewStringUTF(env, title);
			jstring jmsg = (*env)->NewStringUTF(env, msg);
			jstring jbigmsg = (*env)->NewStringUTF(env, bigmsg);
			jstring jticker = (*env)->NewStringUTF(env, ticker);
			jstring jtype = (*env)->NewStringUTF(env, type);
			jstring jicon = (*env)->NewStringUTF(env, icon);
			jstring jsound = (*env)->NewStringUTF(env, sound);
			jstring jactive = (*env)->NewStringUTF(env, active);
			jstring jbroadcastAction = (*env)->NewStringUTF(env, broadcastAction);

			(*env)->CallVoidMethod(env, g_obj, method, pushID, jtitle, jmsg, jbigmsg, jticker, jtype, jicon, jsound, jactive, (jlong)after, jbroadcastAction);

			if (jtitle != 0) (*env)->DeleteLocalRef(env, jtitle);
			if (jmsg != 0) (*env)->DeleteLocalRef(env, jmsg);
			if (jbigmsg != 0) (*env)->DeleteLocalRef(env, jbigmsg);
			if (jticker != 0) (*env)->DeleteLocalRef(env, jticker);
			if (jtype != 0) (*env)->DeleteLocalRef(env, jtype);
			if (jicon != 0) (*env)->DeleteLocalRef(env, jicon);
			if (jsound != 0) (*env)->DeleteLocalRef(env, jsound);
			if (jactive != 0) (*env)->DeleteLocalRef(env, jactive);
			if (jbroadcastAction != 0) (*env)->DeleteLocalRef(env, jbroadcastAction);
		}
	}
}

void CS_pushRegisterLocalpushData(char* jsonPushData) {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "registerLocalpush", "(Ljava/lang/String;)V");
		if (method != 0) {
			jstring jjsonPushData = (*env)->NewStringUTF(env, jsonPushData);

			(*env)->CallVoidMethod(env, g_obj, method, jjsonPushData);

			if (jjsonPushData != 0) (*env)->DeleteLocalRef(env, jjsonPushData);
		}
	}
}

void CS_pushUnRegisterLocalpush(int pushID) {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "unRegisterLocalpush", "(I)V");
		if (method != 0) {
			(*env)->CallVoidMethod(env, g_obj, method, pushID);
		}
	}
}

void CS_pushUnRegisterAllLocalpush() {
	JNIEnv*	env;
		if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
		{
	//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
			jmethodID	method = (*env)->GetMethodID(env, g_cls, "unRegisterAllLocalpush", "()V");
			if (method != 0) {
				(*env)->CallVoidMethod(env, g_obj, method);
			}
		}
}

// apply to 64bit system
void CS_pushRegisterCallbackHandler(PushCallback pushCallback) {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "registerCallbackHandler", "(J)V");
		if (method != 0) {
//			jint cbRef = pushCallback;
            jlong cbRef = pushCallback;
			(*env)->CallVoidMethod(env, g_obj, method, cbRef);
		}
	}
}

void CS_pushUnRegisterCallbackHandler() {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "unRegisterCallbackHandler", "()V");
		if (method != 0) {
			(*env)->CallVoidMethod(env, g_obj, method);
		}
	}
}

void CS_pushSetOperationLocalPushOnRunning(int boolean) {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "setOperationLocalPushOnRunning", "(Z)V");
		if (method != 0) {
			(*env)->CallVoidMethod(env, g_obj, method, (jboolean)boolean);
		}
	}
}

void CS_pushSetOperationGCMPushOnRunning(int boolean) {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "setOperationGCMPushOnRunning", "(Z)V");
		if (method != 0) {
			(*env)->CallVoidMethod(env, g_obj, method, (jboolean)boolean);
		}
	}
}

int CS_pushGetOperationLocalPushOnRunning() {
	jboolean jret;
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "getOperationLocalPushOnRunning", "()Z");
		if (method != 0) {
			jret = (*env)->CallBooleanMethod(env, g_obj, method);
		}
	}
	return jret ? 1 : 0;
}

int CS_pushGetOperationGCMPushOnRunning() {
	jboolean jret;
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "getOperationGCMPushOnRunning", "()Z");
		if (method != 0) {
			jret = (*env)->CallBooleanMethod(env, g_obj, method);
		}
	}
	return jret ? 1 : 0;
}

char* CS_pushGetRegistrationId() {
	JNIEnv*	env;
	jstring jregId = 0;
	char* regId = 0;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
//		jclass userDefined = (*env)->FindClass(env, "com/com2us/module/push/Push");
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "getRegistrationId", "()Ljava/lang/String;");
		if (method != 0) {
			jregId = (jstring)(*env)->CallObjectMethod(env, g_obj, method);
		}
	}

	if(jregId != 0) {
		regId = strdup( (*env)->GetStringUTFChars(env, jregId, 0) );
		(*env)->DeleteLocalRef(env, jregId);
//		if( regId == '\0') regId = 0;
	}
	return regId;
}

void CS_pushRequestPermission(void) {
	JNIEnv*	env;
	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID	method = (*env)->GetMethodID(env, g_cls, "requestPermission", "()V");
		if (method != 0) {
			(*env)->CallVoidMethod(env, g_obj, method);
		}
	}
}

// apply to 64bit system
JNIEXPORT void JNICALL
Java_com_com2us_module_push_Push_jniPushCallback(JNIEnv* env, jobject thiz, jlong cbRef, int callbackType, int pushID, int remainPushCallback) {
	PushCallback pushCallback = cbRef;

	switch(callbackType) {
	case onReceivedGCMPush:
		pushCallback(onReceivedGCMPush, pushID, remainPushCallback);
		break;
	case onReceivedLocalPush:
		pushCallback(onReceivedLocalPush, pushID, remainPushCallback);
		break;
	default:
		break;
	}
}
#endif
